'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _nodeDependencyInjection = require('node-dependency-injection');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _ExtensionConfigurationFileNameException = require('./exception/ExtensionConfigurationFileNameException');

var _ExtensionConfigurationFileNameException2 = _interopRequireDefault(_ExtensionConfigurationFileNameException);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Dependency Injection middleware
 */
var Index = function () {
  /**
   * @param {string} serviceFilePath
   * @param {boolean} compile
   * @param {[]} compilerPass
   * @param {*} logger
   * @param {boolean} containerReferenceAsService
   * @param {String} defaultDir
   * @return {Index.middleware}
   */
  function Index(_ref) {
    var serviceFilePath = _ref.serviceFilePath,
        _ref$compile = _ref.compile,
        compile = _ref$compile === undefined ? false : _ref$compile,
        _ref$compilerPass = _ref.compilerPass,
        compilerPass = _ref$compilerPass === undefined ? [] : _ref$compilerPass,
        _ref$logger = _ref.logger,
        logger = _ref$logger === undefined ? null : _ref$logger,
        _ref$containerReferen = _ref.containerReferenceAsService,
        containerReferenceAsService = _ref$containerReferen === undefined ? false : _ref$containerReferen,
        _ref$defaultDir = _ref.defaultDir,
        defaultDir = _ref$defaultDir === undefined ? null : _ref$defaultDir;

    _classCallCheck(this, Index);

    this._container = new _nodeDependencyInjection.ContainerBuilder(containerReferenceAsService, defaultDir);
    this.serviceFilePath = serviceFilePath;
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = compilerPass[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var pass = _step.value;

        this._container.addCompilerPass(pass);
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    if (logger) {
      this._container.logger = logger;
    }
    if (compile) {
      this._container.compile();
    }
  }

  /**
   * @param {string} serviceFilePath
   */


  _createClass(Index, [{
    key: '_getLoader',


    /**
     * @param extName
     * @return {YamlFileLoader|JsFileLoader|JsonFileLoader|FileLoader}
     * @private
     */
    value: function _getLoader(extName) {
      switch (extName) {
        case 'yaml':
        case 'yml':
          return new _nodeDependencyInjection.YamlFileLoader(this._container);
        case 'js':
          return new _nodeDependencyInjection.JsFileLoader(this._container);
        case 'json':
          return new _nodeDependencyInjection.JsonFileLoader(this._container);
      }

      throw new _ExtensionConfigurationFileNameException2.default(extName + ' is not supported');
    }

    /**
     * @return {ContainerBuilder}
     */

  }, {
    key: 'middleware',


    /**
     * @return {function}
     */
    value: function middleware() {
      var _this = this;

      return function (req, res, next) {
        req.container = _this._container;
        next();
      };
    }
  }, {
    key: 'serviceFilePath',
    set: function set(serviceFilePath) {
      var extName = _path2.default.extname(serviceFilePath).replace('.', '');
      var loader = this._getLoader(extName);
      loader.load(serviceFilePath);
    }
  }, {
    key: 'container',
    get: function get() {
      return this._container;
    }
  }]);

  return Index;
}();

exports.default = Index;